> For the complete documentation index, see [llms.txt](https://docs.xplorpay.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.xplorpay.com/guides/mobile-emv/clearentwrapper/start-transaction.md).

# Start transaction

You can process payments using:

* Card reader (recommended)
* Manual card entry

### Card reader transaction

{% code title="" overflow="wrap" lineNumbers="true" %}

```swift
let saleEntity = SaleEntity(amount: 22.0, tipAmount: 5)
ClearentWrapper.shared.startTransaction(
    with: saleEntity,
    isManualTransaction: false
) { error in
    // Handle completion
}
```

{% endcode %}

#### Runtime callbacks

During the transaction, the SDK provides updates through delegate methods:

{% code title="" overflow="wrap" lineNumbers="true" %}

```swift
func userActionNeeded(action: UserAction) {
    // Prompt user (for example, insert or swipe card)
}
func didReceiveInfo(info: UserInfo) {
    // Display status (for example, processing)
}
```

{% endcode %}

#### Transaction result

{% code title="" overflow="wrap" lineNumbers="true" %}

```swift
func didFinishTransaction(
    response: TransactionResponse?,
    error: ClearentError?
) {
    if error == nil {
        // Transaction succeeded
    } else {
        // Handle error
    }
}
```

{% endcode %}

### Manual card entry

Use manual entry when a reader is unavailable.

{% code title="" overflow="wrap" lineNumbers="true" %}

```swift
let saleEntity = SaleEntity(
    amount: 22.0,
    tipAmount: 5,
    card: "4111111111111111",
    csc: "999",
    expirationDateMMYY: "11/28"
)
ClearentWrapper.shared.startTransaction(
    with: saleEntity,
    manualEntryCardInfo: true
) { error in
    // Handle completion
}
```

{% endcode %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.xplorpay.com/guides/mobile-emv/clearentwrapper/start-transaction.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
